#include "validation.h"

// Check the grammar of the input files.
// You should also check properties of the input.
// E.g., check that a graph is connected.
// TODO: Remove these comments, and summarize your input validator.

int main(int argc, char **argv) {
	InputValidator v;
	long long a = v.read_long_long(1, 1000); v.space();
	long long b = v.read_long_long(1, 1000); v.space();
	long long c = v.read_long_long(1, 1000); v.space();
	long long d = v.read_long_long(1, 1000); v.newline();

	long long s = a+b+c+d;
	v.assert(2 * a < s, "Given sides cannot form a quadrilateral.");
	v.assert(2 * b < s, "Given sides cannot form a quadrilateral.");
	v.assert(2 * c < s, "Given sides cannot form a quadrilateral.");
	v.assert(2 * d < s, "Given sides cannot form a quadrilateral.");
}
