
# Solution to Game Night by Mees
#
# Sliding window solution. Python port of C++ solution.
#
# Expected answer: ACCEPTED.

import sys

inp = sys.stdin.readlines()

n = int(inp[0])
s = inp[1].rstrip()

s = [ord(c) - ord('A') for c in s]

ct = [0]*3

for c in s:
    ct[c] += 1

cur_best = n + 1

for _ in range(2):
    mm = [[0]*3 for _ in range(3)]
    for i in range(ct[0]):
        mm[0][s[i]] += 1
    for i in range(ct[0], ct[0] + ct[1]):
        mm[1][s[i]] += 1
    for i in range(ct[0] + ct[1], n):
        mm[2][s[i]] += 1


    for j in range(n):
        cur_best = min(cur_best, n - mm[0][0] - mm[1][1] - mm[2][2])
        mm[0][s[j]] -= 1
        mm[0][s[(ct[0] + j) % n]] += 1
        mm[1][s[(ct[0] + j) % n]] -= 1
        mm[1][s[(ct[0] + ct[1] + j) % n]] += 1
        mm[2][s[(ct[0] + ct[1] + j) % n]] -= 1
        mm[2][s[j]] += 1

    s.reverse()

print(cur_best) 
