#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using vi = vector<ll>;
using ld = long double;
using vd = vector<ld>;

constexpr ll P1 = 2, P2 = 3, P3 = 5;

int main() {
	int n, a, b;
	cin >> n >> a >> b;

	vi l(n), r(n), t(n);
	for (int i = 0; i < n; ++i)
		cin >> l[i] >> r[i] >> t[i];

	vd x(n, 1.0), nx(n, 0.0);
	int REPS = 750;
	while (REPS--) {
		ld sum = 0.0;
		for (int i = 0; i < n; ++i)
			nx[i] = (P1*t[i] + P2*x[l[i]] + P3*x[r[i]]),
			sum += nx[i];

		// normalize nx into x
		sum /= n;
		for (int i = 0; i < n; ++i)
			x[i] = nx[i] / sum;
	}

	if (abs(x[a] - x[b]) < 1e-12)
		cout << "indistinguishable" << endl;
	else {
		int ans = 0, runs = 3*n + 3;
		while (t[a] == t[b] && --runs)
			if (abs(x[l[a]] - x[l[b]]) < abs(x[r[a]] - x[r[b]]))
				a = l[a], b = l[b];
			else
				a = r[a], b = r[b];

		if (runs > 0)
			cout << ans << endl;
		else
			cout << "indistinguishable" << endl;
	}
}
