import java.util.ArrayList;
import java.util.LinkedList;
import java.util.Scanner;

public class fran_dfs_robustnetwork_scanner {

	static int n, p, t;
	static LinkedList<Integer>[] g;
	static Integer[] time;
	static ArrayList<Integer> leaves;
	
	@SuppressWarnings("unchecked")
	public static void main(String[] args) {
		Scanner reader = new Scanner(System.in);
		n = reader.nextInt();
		p = reader.nextInt();
		g = new LinkedList[n];
		for(int i = 0; i < n; i++) {
			g[i] = new LinkedList<>();
		}
		for(int i = 0; i < n - 1; i++) {
			int a = reader.nextInt();
			int b = reader.nextInt();
			g[a].add(b);
			g[b].add(a);
		}
		time = new Integer[n];
		t = 0;
		leaves = new ArrayList<>();
		dfs(p);
		System.out.println(leaves.size() / 2 + leaves.size() % 2);
		for(int i = 0; i < leaves.size() / 2 + leaves.size() % 2; i++) {
			int j = (i + leaves.size() / 2) % leaves.size();
			System.out.println(leaves.get(i) + " " + leaves.get(j));
		}
		reader.close();
	}
	
	static void dfs(int u) {
		time[u] = t++;
		if(g[u].size() == 1) leaves.add(u);
		for(int v : g[u]) {
			if(time[v] == null) dfs(v);
		}
	}
		
}
